<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER;
require_once($CFG->dirroot . '/blog/lib.php'); // additional blog functions

// get id of post, if none a new one is created
$postid = optional_param('id',null);
$posttags = array();
if(empty($postid)){
    $newpost = true;
}
else{
    $newpost = false;
    // get the entry
    $post = get_record('post','id',$postid);
    // get applied tags
    $taginstances = get_records('blog_tag_instance', 'entryid', $post->id);
    $posttags = array();
    if($taginstances!=false){
        foreach ($taginstances as $taginstance){
            $posttags[] = $taginstance->tagid;
        }
    }
    // check if editing is allowed
    $editallowed = blog_user_can_edit_post($post);
}

// check if in edit mode
$editflag = optional_param('edit',false);
$editing = (empty($editflag)) ? false : true;

// get list of applicable tags (i.e. official tags and personal tags)
$tags = array();
$tags = get_records('tags',null,null,'text ASC');

// ###############################################################################
if (!$newpost && !$editing){ // the given posting is simply displayed
?>
<ps t="<?php momo_print_string('hd_blog')?>" s="false" bo="true">
<pa id="i">
<?php momo_print_header(momo_get_string('hd_blog_entry'), 'pst_posting') ?>
<font class="h3"/><?php momo_print_string('lbl_blog_subject') ?><font class="std"/><br/>
<?php echo($post->subject)?><br/>
<font class="h3"/><?php momo_print_string('lbl_blog_message') ?><font class="std"/><br/>
<?php echo($post->summary)?><br/>
<font class="h3"/><?php momo_print_string('lbl_blog_tags') ?><font class="std"/><br/>
<?php
    // print tags
    if(empty($posttags)){
        momo_print_string('lbl_blog_no_tags');
    }
    else{
        for ($i = 0; $i < count($posttags); $i++) {
            echo(get_field('tags','text','id',$posttags[$i]));
            if( ($i + 1) <  count($posttags)){
                   echo(', ');
            }
        }
    }
    // if editing is allowed, show controls
    if($editallowed){ ?>
<br align="center"/><hr/>
<menu url="blog/blog_entry.php&amp;id=<?php echo($post->id)?>&amp;edit=true" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('edit') ?>" word="<?php momo_print_string('lbl_blog_edit')?>" full="false"/><br/>
<menu url="blog/blog.php&amp;entry=<?php echo($post->id)?>&amp;action=delete" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('delete') ?>" word="<?php momo_print_string('lbl_blog_delete')?>" full="false"/><br/>
<?php } ?>
<menu url="blog/blog.php" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('ok') ?>" word="<?php momo_print_string('nav_ok')?>" full="false"/><br/>
</page>
</pagesuite>
<?php }
// ###############################################################################
else if($newpost){ // a new entry is created
?>
<ps t="<?php momo_print_string('hd_blog')?>" s="false" bo="false">
<pa id="i">
<?php momo_print_header(momo_get_string('lbl_blog_add'), 'add') ?>
<upload type="form"/>
<font class="h3"/><?php momo_print_string('lbl_blog_subject') ?><font class="std"/><br/>
<textbox id="subject" size="20" /><br/>
<font class="h3"/><?php momo_print_string('lbl_blog_message') ?><font class="std"/><br/>
<textbox id="message" size="20" /><br/>
<font class="h3"/><?php momo_print_string('lbl_blog_publishstate') ?><font class="std"/><br/>
<checkbox id="draft" checked="true" group="publish" /> <?php momo_print_string('lbl_blog_state_draft')?><br/>
<checkbox id="site" checked="false" group="publish" /> <?php momo_print_string('lbl_blog_state_site')?><br/>
<checkbox id="public" checked="false" group="publish" /> <?php momo_print_string('lbl_blog_state_public')?><br/>
<br align="center" />
<menu url="t" type="i" dt="mc" di="<?php momo_print_icon_path('add')?>" word="<?php momo_print_string('lbl_blog_addtag')?>" full="false"/>
<br align="left" />
<upload type="hidden" name="action" value="save" />
<br align="center"/><hr/>
<upload type="submit" url="blog/blog.php" location="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('ok') ?>" menuTag="<?php momo_print_string('nav_submit')?>" full="false"/><br/>
<menu url="blog/blog.php" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('cancel') ?>" word="<?php momo_print_string('nav_cancel')?>" full="false"/>
</pa>

<?php }
// ###############################################################################
else if ($editing){ // an existing entry should be edited

?>
<ps titel="<?php momo_print_string('hd_blog')?>" s="false" bo="false">
<pa id="i">
<?php momo_print_header(momo_get_string('lbl_blog_edit'), 'pst_posting') ?>
<upload type="form"/>
<font class="h2"/><?php momo_print_string('lbl_blog_subject') ?><font class="std"/><br/>
<textbox id="subject" size="20" value="<?php echo($post->subject)?>"/><br/>
<font class="h2"/><?php momo_print_string('lbl_blog_message') ?><font class="std"/><br/>
<textbox id="message" size="20" value="<?php echo($post->summary)?>"/><br/>
<font class="h2"/><?php momo_print_string('lbl_blog_publishstate') ?><font class="std"/><br/>
<checkbox id="draft" checked="<?php echo ($post->publishstate == 'draft') ? "true" : "false" ?>" group="publish" /> <?php momo_print_string('lbl_blog_state_draft')?><br/>
<checkbox id="site" checked="<?php echo ($post->publishstate == 'site') ? "true" : "false" ?>" group="publish" /> <?php momo_print_string('lbl_blog_state_site')?><br/>
<checkbox id="public" checked="<?php echo ($post->publishstate == 'public') ? "true" : "false" ?>" group="publish" /> <?php momo_print_string('lbl_blog_state_public')?><br/>
<br align="center" />
<menu url="t" type="i" dt="mc" di="<?php momo_print_icon_path('add') ?>" word="<?php momo_print_string('lbl_blog_addtag')?>" full="false"/>
<br align="left" />
<upload type="hidden" name="action" value="update" />
<upload type="hidden" name="entry" value="<?php echo($post->id) ?>" />
</page>
<?php }
// ###############################################################################
// tags page is the same for both
?>
<page id="t">
<font class="h2"/>
<?php momo_print_string('lbl_blog_addtag')?>
<font class="std"/><br/><hr/>
<?php
    foreach($tags as $tag){ ?>
<checkbox id="<?php echo($tag->id) ?>" checked="<?php echo (in_array($tag->id,$posttags))?"true":"false"?>"/> <?php p(momo_truncate($tag->text)) ?><br/>
<?php } ?>
<br align="center"/><hr/>
<upload type="submit" url="blog/blog.php" location="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('ok') ?>" menuTag="<?php momo_print_string('nav_submit')?>" full="false"/><br/>
<menu url="blog/blog.php" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('cancel')?>" word="<?php momo_print_string('nav_cancel')?>" full="false"/>
</pa>
</ps>