<?php
	/* 	gpsupdate.php, Sandra Schadenbauer, 2007
		basierend auf gpsudate.php (GPS demo script) von Andreas Forstinger, 2007 */

	global $CFG, $USER;

	/// get parameters

    // get location header sent by MOMO Client
    $locationheader = momo_basic_get_header($CFG->momo_mle_param_location, null);
	//momo_log($locationheader,$action='gps debug',$url='');

	$referer = momo_basic_get_header(MLIBERA_REFERER, null);
	//momo_log("referer: ".$referer,$action='gps debug',$url='');


    // get optional request header
    $gpsparam = optional_param('gps',null);

    if($locationheader == null)
        $locationheader=$gpsparam;

	/// convert values

	//zum Testen von locationapi
	//$locationheader="55:57.5292|-3:10.8171|||0.0|M|NaN|NaN|NaN|NaN|||||locationapi|1235617817623";

	$header=explode("|",$locationheader);

	//VZ initialisieren
	$vzLat=0;
	$vzLng=0;

	//Lat und Lng initialisieren
	$lat=0;
	$lng=0;

	list($latGrad,$latMin)=explode(":",$header[0]);
	list($lngGrad,$lngMin)=explode(":",$header[1]);

	//NMEA Daten
	if(strcmp($header[14],"NMEA")==0)
	{
		//VZ f�r Lat und Lng
		$vzLat=1;
		if(strcmp($header[2],"S")==0)
			$vzLat=-1;
		$vzLng=1;
		if(strcmp($header[3],"W")==0)
			$vzLng=-1;
	}

	//Locationapi Daten
	if(strcmp($header[14],"locationapi")==0)
	{
		//VZ f�r Lat und Lng
		$vzLat=1;
		if($latGrad<0)
		{
			$latGrad=bcmul($latGrad,'-1',8);
			$vzLat=-1;
		}
		$vzLng=1;
		if($lngGrad<0)
		{
			$lngGrad=bcmul($lngGrad,'-1',8);
			$vzLng=-1;
		}
	}

	//Lat und Lng berechnen
	$lat=bcmul(bcadd($latGrad,bcdiv($latMin,'60',8),8),$vzLat,8);
	$lng=bcmul(bcadd($lngGrad,bcdiv($lngMin,'60',8),8),$vzLng,8);
	//momo_log(date("d.m.y - H:i:s",time()).": Lat=".$lat." Lng=".$lng,$action='gps debug',$url='');

	 // write gps info to db
    $gpsTrack = new object();
    $gpsTrack->userid = $USER->id;
    $gpsTrack->lat = $lat; // TODO
    $gpsTrack->lng = $lng; // TODO
    $gpsTrack->timestamp = time();

	//Kurse, in denen der User Student ist, aus der DB lesen
	$courses=array();
	$myCourses=get_my_courses($USER->id);
	foreach($myCourses as $myCourse)
	{
		$courses[]=$myCourse->id;
	}
	/// check if location based data is available

	$gpsareas = get_records_select('gpsloc',"game=0");

	//Area von GPSTrack Objekt mit 0 initalisieren (falls der Punkt in keinem Polygon liegt steht in der DB '0')
	$gpsTrack->area=0;

	//wenn GPSLoc Objekte in der DB vorhanden sind
	if($gpsareas)
	{
		foreach ($gpsareas as $area)
		{
			//ist der GPS Bereich in einem Kurs, in dem der User Student ist?
			$inCourse=false;
			for($i=0; $i<count($courses); $i++)
			{
				if($courses[$i]==$area->course)
					$inCourse=true;
			}

			if($inCourse==true)
			{
				//Lat und Lng Koordinaten werden in 2 Arrays aufgeteilt
				$xPoints=array();
				$yPoints=array();
				$anzPoints=0;
				$points=$header=explode("|",$area->gpspoints);

				foreach($points as $point)
				{
					$lnglat=explode(",",$point);
					$xPoints[]=$lnglat[1];
					$yPoints[]=$lnglat[0];
					$anzPoints++;
				}

				//Algorithmus um herauszufinden ob sich ein Punkt in einem Polygon befindet
				$j=0;
				$oddNotes=false;
				for ($i = 0; $i < $anzPoints; $i++)
				{
					$j++;
					if($j==$anzPoints)
						$j=0;
					if(($yPoints[$i]<$lng && $yPoints[$j]>=$lng)||($yPoints[$j]<$lng && $yPoints[$i]>=$lng))
					{
						$result=bcadd($xPoints[$i],bcmul(bcdiv(bcsub($lng,$yPoints[$i],8),bcsub($yPoints[$j],$yPoints[$i],8),8),bcsub($xPoints[$j],$xPoints[$i],8),8),8);
						if($result<$lat)
							$oddNotes=!$oddNotes;
					}
				}

				//Wenn sich der Punkt im Polygon befindet...
				if($oddNotes==true)
				{
					//momo_log(date("d.m.y - H:i:s",time()).": Bereich=".$area->name,$action='gps debug',$url='');

					//GPS Track Objekt mit GPS Bereichsnummer bef�llen
					$gpsTrack->area=$area->id;


					//Variable die bestimmt ob die Informationen zum GPS Bereich angezeigt werden
					$showArea=false;

					//letzte Position aus DB lesen
					$lastposition = get_records_select('gpstrack',"userid = $USER->id", 'timestamp DESC', '*', 0, 1);
					if($lastposition)
					{
						foreach($lastposition as $position)
						{
							//Befindet sich die letzte Position im selben Polygon wie die aktuelle?
							if($position->area==$area->id)
							{
								//letzte GPS Bereichsver�nderung aus der DB lesen
								$lastareas = get_records_select('gpschange',"userid=$USER->id",'timestamp DESC','*',0,1);
								if($lastareas)
								{
									foreach($lastareas as $lastarea)
									{
										//aktuelle Zeit bestimmen und mit der Zeit der letzten GPS Bereichver�nderung vergleichen
										//wenn seit der letzten Bereichver�nderung mehr als 2min vergangen sind wird die Information angezeigt
										//und ein neues GPSBereichver�nderungsobjekt in die DB geschrieben
										$curTime=time();
										$difference=bcsub($curTime,$lastarea->timestamp,0);
										//momo_log(date("d.m.y - H:i:s",time()).": ".$difference." sec",$action='gps debug',$url='');
										if($difference>=120)
										{
											//momo_log(date("d.m.y - H:i:s",time()).": ".$difference." >=120",$action='gps debug',$url='');
											$gpsChange=new object();
											$gpsChange->userid=$USER->id;
											$gpsChange->timestamp=time();
											$gpsChange->area=$area->id;
											insert_record('gpschange',$gpsChange);
											$showArea=true;
										}
									}
								}
								//falls es noch kein GPS Bereichsver�nderungsobjekt in der DB gibt
								else
								{
									//momo_log('kein gps change vorhanden',$action='gps debug',$url='');
									$gpsChange=new object();
									$gpsChange->userid=$USER->id;
									$gpsChange->timestamp=time();
									$gpsChange->area=$area->id;
									insert_record('gpschange',$gpsChange);
									$showArea=true;
								}
							}
							//wenn sich die aktuelle Position in einem anderen GPS Bereich befindet als die letzte bzw. wenn die letzte Position in keinem GPS Bereich war
							else
							{
								//momo_log('neuer gps bereich',$action='gps debug',$url='');

								$gpsChange=new object();
								$gpsChange->userid=$USER->id;
								$gpsChange->timestamp=time();
								$gpsChange->area=$area->id;
								insert_record('gpschange',$gpsChange);
								$showArea=true;
							}
						}
					}
					//falls keine letzte Position vorhanden ist
					else
					{
						//momo_log('keine lastposition',$action='gps debug',$url='');
						$gpsChange=new object();
						$gpsChange->userid=$USER->id;
						$gpsChange->timestamp=time();
						$gpsChange->area=$area->id;
						insert_record('gpschange',$gpsChange);
						$showArea=true;
					}

					//wenn die Informationen des GPS Bereich angezeigt werden sollen
					if($showArea==true)
					{
						//momo_log(date("d.m.y - H:i:s",time()).": showArea=true",$action='gps debug',$url='');
						$gpslocMod=0;

						//ID des Moduls mit dem namen 'gpsloc' aus DB lesen
						$modules=get_records_sql("select id from ".$CFG->prefix."modules where name='gpsloc'");
						foreach($modules as $module)
						{
							$gpslocMod=$module->id;
						}

						//Section in der sich der aktuelle GPS Bereich befindet aus DB lesen
						//(= Section in der ein Objekt mit der GPS Loc Modulnummer und der ID des GPS Bereichs befindet)
						$sections=get_records_sql("select section from ".$CFG->prefix."course_modules where module=".$gpslocMod." and instance=".$area->id);
						$curSection=0;
						foreach($sections as $section)
						{
							$curSection=$section->section;
						}

						//�berpr�fen ob sich weitere Aktivit�ten in der Section befinden
						//wenn ja, werden die Informationen angezeigt
						$activities=get_records_sql("select id,module from ".$CFG->prefix."course_modules where section=".$curSection." and instance<>".$area->id);
						if($activities)
						{
							//Session mit den ben�tigten Werten
							$_SESSION["Section"]=$curSection;
							$_SESSION["Area"]=$area->id;
							$_SESSION["Name"]=$area->name;
							$_SESSION["Description"]=$area->description;

							//Link zu der Seite mit Informationen
							$link="|gps/gpsactivities.php|m";

							//Info Msg
							$msg="Sie befinden sich im Bereich '".$area->name."'. Wollen Sie den Bereich aufrufen?";

							//Info anzeigen
							echo "alert$link|$msg";
						}
					}
					$gpsTrack->timestamp=time();
					insert_record('gpstrack',$gpsTrack);
				}
			}
		}
	}

	/// write to db
	if($gpsTrack->area==0)
	{
    	insert_record('gpstrack',$gpsTrack);
	}
?>