<?php /* tag.php (c)2008, Andreas Forstinger, www.mobilemoodle.org */
    // This script is referenced by Semacode tags generated with the Semacode module.
    // According to the type of tag decoded, necessary action is taken.

    require_once('config.php');
    global $CFG, $USER;

    // get id from request
    $id = required_param('id', PARAM_INT); // tag id

    // get tag object
    if(!$tag = get_record('semacode','id',$id)){
        // no such tag found
        print_error('error_not_found','semacode');
    }

    // check type of tag
    switch ($tag->type) {

        case 'u': // external url type
            redirect($tag->url);
            break;

        case 'c': // course link type
            if($course = get_record('course', 'id', $tag->target)){
                redirect($CFG->wwwroot . '/course/view.php?id=' . $course->id);
            }
            else{
                print_error('error_outdated', 'semacode');
            }
            break;

        case 'a': // activity link type
            // get module information from course
            if($activity = get_record_sql("SELECT cm.id, cm.instance, m.name
                                            FROM {$CFG->prefix}course_modules cm,
                                             {$CFG->prefix}modules m
                                              WHERE cm.id = '$tag->target' AND
                                              m.id = cm.module")) {
                // redirect to module page
                redirect($CFG->wwwroot . "/mod/$activity->name/view.php?id=$activity->id");
            }
            else{
                print_error('error_outdated', 'semacode');
            }
            break;

        case 'l': // location type
            print_error('error_location_clientneeded', 'semacode');
            break;

        default:
            print_error('error_type_notsupported', 'semacode');
            break;
    }
?>